--[[--------------------------------------------------
-- Juked by Robrman, Inspired by Kollektiv's InterruptBar
-- Version 1.2.4
CHANGELOG:
--Fixed possible problem with Gnaw if used by a transformed ghoul (Thanks Damnationx)
--Fixed Death Coil cooldown to account for Warlock 4 piece bonus -30 seconds (Thanks Damnationx)
--Fixed cooldown timer restarting (if same CD is popped, restart timer. Thanks Damnationx)
--Added Inner Focus   {spellID=89485, time=45, prio=false},--Inner Focus     (Thanks Sazalolz, cant believe i missed it)
--Added /juked prioonly   this will ONLY display cooldowns for spells marked with prio=true
--Added noCD option to disable the numeric cooldown from Juked 
--Fixed some cooldown durations(Thanks Sazalolz for pointing it out)
--Externalized the spell table(Thanks Sazalolz for the suggestion)
--Added test for all modes
--Added a fix for some versions of omniCC
--Fixed Rebuke spellID
--Addon can now be accessed from /juked   /jd   and   /ib(kept this cause i kept typing it by accident)
--Added the option to grow the bars upward from the anchor /juked
TODO:
--Add the ability to hide prio and/or the main bar separately
--I should probably rewrite the help menu, very cluttered right now
	-/jd help <command> likely added soon
----------------------------------------------------]]

JukedDB = JukedDB or { scale = 1, hidden = false, smart=false,prio = false, cols=6, colsPrio=6, arenaOnly=false, bgOnly=false, lock = false,grow=-1, noCD=false,prioOnly=false }
local abilities = {}
local order
local arena=false
local bg=false
local band = bit.band
local spell_table=spell_table
--[[
TO ADD:
-- Smoke bomb once it can be tracked
--]]
-----------------------------------------------------
-----------------------------------------------------
if spell_table==nil then ChatFrame1:AddMessage("NOT LOADED",0,1,0) end
for k,spell in ipairs(spell_table) do
	local name,_,spellicon = GetSpellInfo(spell.spellID)	
	abilities[spell.spellID] = { icon = spellicon, duration = spell.time }
end

local frame
local bar
local bar2

local x = -45
local x2 = -45
local y2 = 0
local count2 = 0
local count=0
local y=0
local totalIcons=0
local GetTime = GetTime
local ipairs = ipairs
local pairs = pairs
local select = select
local floor = floor
local band = bit.band
local GetSpellInfo = GetSpellInfo


local GROUP_UNITS = bit.bor(0x00000010, 0x00000400)

local activetimers = {}

local size = 0
local function getsize()
	size = 0
	for k in pairs(activetimers) do
		size = size + 1
	end
end

local function isInBG()
	local a,type = IsInInstance()
	if (type == "pvp") then
		return true
	end
	return false
end

local function isInArena()
	local _,type = IsInInstance()
	if (type == "arena") then
		return true
	end
	return false
	
end
local function isPrio(ability)
	for _,v in ipairs(spell_table) do
		if v.spellID==ability then
			return v.prio
		end
	end
	return false
end

local function Juked_AddIcons()
	for _,ability in ipairs(spell_table) do
		local btn = CreateFrame("Frame",nil,bar)
		btn:SetWidth(30)
		btn:SetHeight(30)
		
		if JukedDB.prio and isPrio(ability.spellID) then
			btn:SetPoint("CENTER",bar2,"CENTER",x2,y2)
		else
			btn:SetPoint("CENTER",bar,"CENTER",x,y)
		end
			
		btn:SetFrameStrata("LOW")
		local cd = CreateFrame("Cooldown",nil,btn)
		cd.noomnicc = not JukedDB.noCD
		cd.noOCC = not JukedDB.noCD
		cd.noCooldownCount = not JukedDB.noCD
		
		cd:SetAllPoints(true)
		cd:SetFrameStrata("LOW")
		cd:Hide()
		
		local texture = btn:CreateTexture(nil,"BACKGROUND")
		texture:SetAllPoints(true)
		texture:SetTexture(abilities[ability.spellID].icon)
		texture:SetTexCoord(0.07,0.9,0.07,0.90)
	
		local text = cd:CreateFontString(nil,"ARTWORK")
		text:SetFont(STANDARD_TEXT_FONT,18,"OUTLINE")
		text:SetTextColor(1,1,0,1)
		text:SetPoint("LEFT",btn,"LEFT",1,0)
		
		btn.texture = texture
		btn.text = text
		btn.duration = abilities[ability.spellID].duration
		btn.cd = cd
		
		if JukedDB.prio and isPrio(ability.spellID) then
			bar2[ability.spellID] = btn
			if (JukedDB.prioOnly and not isPrio(ability.spellID)) then bar2[ability.spellID]:Hide() end
			x2 = x2 + 30
			count2 = count2 + 1
			totalIcons = totalIcons + 1
			if count2 >= JukedDB.colsPrio and JukedDB.colsPrio > 0 then
				y2 = y2 - 30 * JukedDB.growUp
				x2 =-45
				count2=0
			end
		else
			bar[ability.spellID] = btn
			if (JukedDB.prioOnly and not isPrio(ability.spellID)) then bar[ability.spellID]:Hide() end
			x = x + 30
			count = count + 1
			totalIcons = totalIcons + 1
			if count >= JukedDB.cols and JukedDB.cols > 0 then
				y = y - 30 * JukedDB.growUp
				x=-45
				count=0
			end
		end
	end
	x = -45
	count=0
	y=0
	active=0
	x2 = -45
	count2=0
	y2=0
end

local function Juked_AddIcon(ability)
if (JukedDB.prioOnly and not isPrio(ability)) then return end
	if JukedDB.prio and isPrio(ability) then
		if not bar2[ability]:IsVisible() then
			bar2[ability]:SetPoint("CENTER",bar2,"CENTER",x2,y2)
			bar2[ability]:Show()
			x2 = x2 + 30
			count2 = count2 + 1
			if count2 >= JukedDB.colsPrio and JukedDB.colsPrio > 0 then
				y2 = y2 - 30 * JukedDB.growUp
				x2=-45
				count2=0
			end
		end	
	else
		if not bar[ability]:IsVisible() then
			bar[ability]:SetPoint("CENTER",bar,"CENTER",x,y)
			bar[ability]:Show()
			x = x + 30
			count = count + 1
			if count >= JukedDB.cols and JukedDB.cols > 0 then
				y = y - 30 * JukedDB.growUp
				x=-45
				count=0
			end
		end
	end
end


local function Juked_SavePosition()
	local point, _, relativePoint, xOfs, yOfs = bar:GetPoint()
	if not JukedDB.Position then 
		JukedDB.Position = {}
	end
	--first bar
	JukedDB.Position.point = point
	JukedDB.Position.relativePoint = relativePoint
	JukedDB.Position.xOfs = xOfs
	JukedDB.Position.yOfs = yOfs
	--second bar
	local point, _, relativePoint, xOfs, yOfs = bar2:GetPoint()
	JukedDB.Position.point2 = point
	JukedDB.Position.relativePoint2 = relativePoint
	JukedDB.Position.xOfs2 = xOfs
	JukedDB.Position.yOfs2 = yOfs
end

local function Juked_LoadPosition()
	if JukedDB.Position then
		bar:SetPoint(JukedDB.Position.point,UIParent,JukedDB.Position.relativePoint,JukedDB.Position.xOfs,JukedDB.Position.yOfs)
		if JukedDB.Position.point2 then
			bar2:SetPoint(JukedDB.Position.point2,UIParent,JukedDB.Position.relativePoint2,JukedDB.Position.xOfs2,JukedDB.Position.yOfs2)
		else
			bar2:SetPoint("CENTER", UIParent, "CENTER")
		end
	else
		bar:SetPoint("CENTER", UIParent, "CENTER")
		bar2:SetPoint("CENTER", UIParent, "CENTER")
	end
end

local function Juked_Repos()
	if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then return end
	if not JukedDB.smart then
		x = -45
		count=0
		y=0
		x2 = -45
		count2 = 0
		y2 = 0
		active=0
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				bar2[v.spellID]:Hide()
			else
				bar[v.spellID]:Hide()
			end
			Juked_AddIcon(v.spellID)
			if JukedDB.hidden then
				if JukedDB.prio and isPrio(v.spellID) then
					bar2[v.spellID]:Hide()
				else
					bar[v.spellID]:Hide()
				end
			end
		end
	else 
		if JukedDB.hidden then
			x = -45
			count=0
			y=0
			x2 = -45
			count2 = 0
			y2 = 0
			for _,v in ipairs(spell_table) do
				if JukedDB.prio and isPrio(v.spellID) then
					bar2[v.spellID]:Hide() 
				else
					bar[v.spellID]:Hide()
				end
				if activetimers[v.spellID] then
					Juked_AddIcon(v.spellID)
				end
			end
		end
	end
end

local function Juked_UpdateBar()
	bar:SetScale(JukedDB.scale)
	bar2:SetScale(JukedDB.scale)
		
	
	if JukedDB.prio then
		bar2:Show()
	end
	if not JukedDB.prio then
		for _,v in ipairs(spell_table) do
			if isPrio(v.spellID) and bar2[v.spellID] then
				bar[v.spellID]=bar2[v.spellID] 
			end
		end
		bar2:Hide()
	elseif JukedDB.prio and table.getn(bar2) == 0 then
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				if bar[v.spellID] and not bar2[v.spellID] then
					bar2[v.spellID]=bar[v.spellID]
				end
			end
		end
	end

	if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then 
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				bar2[v.spellID]:Hide()
			else
				bar[v.spellID]:Hide()
			end
		end
		return
	end
	if JukedDB.hidden or JukedDB.smart then
		if JukedDB.smart then
			x = -45
			count=0
			y=0
			x2 = -45
			y2 = 0
			count2 = 0
		end
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				bar2[v.spellID]:Hide()
				bar2[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar2[v.spellID].cd.noOCC = not JukedDB.noCD
				bar2[v.spellID].cd.noCooldownCount = not JukedDB.noCD
			else	
				bar[v.spellID]:Hide()
				bar[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar[v.spellID].cd.noOCC = not JukedDB.noCD
				bar[v.spellID].cd.noCooldownCount = not JukedDB.noCD
			end
		end
	else
		for _,v in ipairs(spell_table) do
			if JukedDB.prio and isPrio(v.spellID) then
				bar2[v.spellID]:Show() 
				bar2[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar2[v.spellID].cd.noOCC = not JukedDB.noCD
				bar2[v.spellID].cd.noCooldownCount = not JukedDB.noCD
			else
				bar[v.spellID]:Show() 
				bar[v.spellID].cd.noomnicc = not JukedDB.noCD
				bar[v.spellID].cd.noOCC = not JukedDB.noCD
				bar[v.spellID].cd.noCooldownCount = not JukedDB.noCD
			end
		end
	end
		if JukedDB.prioOnly then
			for _,v in ipairs(spell_table) do
			if not isPrio(v.spellID) then
			--	bar2[v.spellID]:Hide()
			--else
				bar[v.spellID]:Hide()
			end
		end
	end
	if JukedDB.lock then
		bar:EnableMouse(false)
		bar2:EnableMouse(false)
	else
		bar:EnableMouse(true)
		bar2:EnableMouse(true)
	end
end

local function Juked_CreateBar()
	bar = CreateFrame("Frame", nil, UIParent)
	bar:SetMovable(true)
	bar:SetWidth(120)
	bar:SetHeight(30)
	bar:SetClampedToScreen(true) 
	bar:SetScript("OnMouseDown",function(self,button) if button == "LeftButton" then self:StartMoving() end end)
	bar:SetScript("OnMouseUp",function(self,button) if button == "LeftButton" then self:StopMovingOrSizing() Juked_SavePosition() end end)
	bar:Show()

	bar2 = CreateFrame("Frame", nil, UIParent)
	bar2:SetMovable(true)
	bar2:SetWidth(120)
	bar2:SetHeight(30)
	bar2:SetClampedToScreen(true) 
	bar2:SetScript("OnMouseDown",function(self,button) if button == "LeftButton" then self:StartMoving() end end)
	bar2:SetScript("OnMouseUp",function(self,button) if button == "LeftButton" then self:StopMovingOrSizing() Juked_SavePosition() end end)
	bar2:Show()
	
	Juked_AddIcons()
	Juked_UpdateBar()
	Juked_LoadPosition()
end

local function Juked_UpdateText(text,cooldown)
if  JukedDB.noCD then return end
	if cooldown < 100 then 
		if cooldown <= 0.5 then
			text:SetText("")
		elseif cooldown < 10 then
			text:SetFormattedText(" %d",cooldown)
		else
			text:SetFormattedText("%d",cooldown)
		end
	else
		local m=floor((cooldown+30)/60)
		text:SetFormattedText("%dm",m)
	end
	if cooldown < 6 then 
		text:SetTextColor(1,0,0,1)
	else 
		text:SetTextColor(1,1,0,1) 
	end
end

local function Juked_StopAbility(ref,ability)
	if JukedDB.hidden then ref:Hide() end
	if activetimers[ability] then activetimers[ability] = nil end
	ref.text:SetText("")
	ref.cd:Hide()
	if JukedDB.hidden and JukedDB.smart then Juked_Repos() end
end

local time = 0
local function Juked_OnUpdate(self, elapsed)
	time = time + elapsed
	if time > 0.25 then
		getsize()
		for ability,ref in pairs(activetimers) do
			ref.cooldown = ref.start + ref.duration - GetTime()
			if ref.cooldown <= 0 then
				Juked_StopAbility(ref,ability)
			else 
				Juked_UpdateText(ref.text,floor(ref.cooldown+0.5))
			end
		end
		if size == 0 then frame:SetScript("OnUpdate",nil) end
		time = time - 0.25
	end
end

local function Juked_StartTimer(ref,ability)
	if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then return end
	if JukedDB.hidden or JukedDB.smart then
		ref:Show()
	end
	--if not activetimers[ability] then
		local duration
		activetimers[ability] = ref
		ref.cd:Show()
		ref.cd:SetCooldown(GetTime()-0.40,ref.duration)
		ref.start = GetTime()
		Juked_UpdateText(ref.text,ref.duration)
	--end
	frame:SetScript("OnUpdate",Juked_OnUpdate)
end

local function Juked_COMBAT_LOG_EVENT_UNFILTERED(...)
	local spellID, ability, useSecondDuration
	return function(_, eventtype, _, srcName, srcFlags, _, dstName, dstFlags, id)
		if (band(srcFlags, 0x00000040) == 0x00000040 and (eventtype == "SPELL_CAST_SUCCESS" or eventtype == "SPELL_AURA_APPLIED")) then 
			spellID = id
		else
			return
		end
		if spellID == 49376 then spellID = 16979; useSecondDuration = true end -- Feral Charge - Cat -> Feral Charge - Bear
		if spellID == 91797 then spellID = 91800; end
		if (JukedDB.prioOnly and not isPrio(spellID)) then return end
		if (JukedDB.bgOnly and not bg and JukedDB.arenaOnly and not arena) or (not JukedDB.bgOnly and JukedDB.arenaOnly and not arena) or (not JukedDB.arenaOnly and JukedDB.bgOnly and not bg) then return end
		local cold_snap={82676,44572,45438}
		local prep={1766,1856,36554,51722}
		if spellID == 11958 then --cold snap 82676 Ring of Frost -- 44572 Deep Freeze -- 45438 Ice Block
			if JukedDB.prio and isPrio(ability) then
				for _,abil in ipairs(cold_snap) do
					if activetimers[abil] then
						Juked_StopAbility(bar2[abil],abil)
					end
				end
			else
				for _,abil in ipairs(cold_snap) do
					if activetimers[abil] then
						Juked_StopAbility(bar[abil],abil)
					end
				end
			end
		elseif spellID == 14185 then --prep
			if JukedDB.prio and isPrio(ability) then
				for _,abil in ipairs(prep) do
					if activetimers[abil] then
						Juked_StopAbility(bar2[abil],abil)
					end
				end
			else
				for _,abil in ipairs(prep) do
					if activetimers[abil] then
						Juked_StopAbility(bar[abil],abil)
					end
				end
			end
			--[[ 1766  Kick 1856  Vanish 36554 Shadowstep 76577 Smoke Bomb 51722 Dismantle
				Non tracked: Sprint, Smoke Bomb]]
		end
		useSecondDuration = false

		if abilities[spellID] then	
			if useSecondDuration and spellID == 16979 then
				if JukedDB.prio and isPrio(spellID) then
					bar2[spellID].duration=30
				else
					bar[spellID].duration=30
				end
			elseif spellID == 16979 then
				if JukedDB.prio and isPrio(spellID) then
					bar2[spellID].duration=15
				else
					bar[spellID].duration=15
				end
			end
			if JukedDB.smart then
				Juked_AddIcon(spellID)
			end
			if JukedDB.prio and isPrio(spellID) then
				Juked_StartTimer(bar2[spellID],spellID)
			else
				Juked_StartTimer(bar[spellID],spellID)
			end
		end
	end
end

Juked_COMBAT_LOG_EVENT_UNFILTERED = Juked_COMBAT_LOG_EVENT_UNFILTERED()


local function Juked_ResetAllTimers()
	for _,ability in ipairs(spell_table) do
		if JukedDB.prio and isPrio(ability.spellID) then
			Juked_StopAbility(bar2[ability.spellID],ability.spellID)
		else
			Juked_StopAbility(bar[ability.spellID],ability.spellID)
		end
	end
	if not JukedDB.smart and not (JukedDB.smart and JukedDB.hidden) then
		Juked_Repos()
	end

end

local function Juked_Reset()
	JukedDB = JukedDB or { scale = 1, hidden = false, smart=false,prio = false, cols=6, colsPrio=6, arenaOnly=false, bgOnly=false, lock = false,growUp=1 ,noCD=false,prioOnly=false }
	Juked_ResetAllTimers()
	Juked_UpdateBar()
	Juked_LoadPosition()
end
local function Juked_PLAYER_ENTERING_WORLD(self)
	arena=isInArena()
	bg=isInBG()
	Juked_Reset()
end
local function Juked_Test()
	if JukedDB.smart and JukedDB.hidden then 
		Juked_Repos()
	end
	if JukedDB.prioOnly then 
		for _,ability in ipairs(spell_table) do
			if isPrio(ability.spellID) then
			if JukedDB.smart then Juked_AddIcon(ability.spellID) end
				if JukedDB.prio then
					Juked_StartTimer(bar2[ability.spellID],ability.spellID)
				else
					Juked_StartTimer(bar[ability.spellID],ability.spellID)
				end
			end
		end
	else
		for _,ability in ipairs(spell_table) do
			if JukedDB.smart then Juked_AddIcon(ability.spellID) end
			if JukedDB.prio and isPrio(ability.spellID) then
				Juked_StartTimer(bar2[ability.spellID],ability.spellID)
			else
				Juked_StartTimer(bar[ability.spellID],ability.spellID)
			end
		end
	end
end


local cmdfuncs = {
	scale = function(v) JukedDB.scale = v; Juked_UpdateBar() end,
	hidden = function() JukedDB.hidden = not JukedDB.hidden; Juked_UpdateBar() end,
	smart = function() JukedDB.smart = not JukedDB.smart; Juked_Reset() end,
	lock = function() JukedDB.lock = not JukedDB.lock; Juked_UpdateBar() end,
	prio = function() JukedDB.prio = not JukedDB.prio; Juked_UpdateBar();Juked_Repos() end,
	arenaonly = function() JukedDB.arenaOnly = not JukedDB.arenaOnly; Juked_Reset() end,
	bgonly = function() JukedDB.bgOnly = not JukedDB.bgOnly; Juked_Reset() end,
	growup=function() JukedDB.growUp=JukedDB.growUp*-1;Juked_Repos(); end,
	nocd=function() JukedDB.noCD = not JukedDB.noCD;Juked_Reset(); end,
	prioonly=function()JukedDB.prioOnly=not JukedDB.prioOnly;Juked_Reset()  end,
	cols = function(id,v) 
		if not id or not v then return end
		if ((id == 1 or id == 2) and v >= 0) then 
			if id==1 then
				JukedDB.cols = v
			elseif id==2 then
				JukedDB.colsPrio = v
			end
				Juked_Repos()
		end
	end,
	reset = function() Juked_Reset() end,
	test = function() Juked_Test() end,
}

local cmdtbl = {}
function Juked_Command(cmd)
	for k in ipairs(cmdtbl) do
		cmdtbl[k] = nil
	end
	for v in gmatch(cmd, "[%d|%a|.]+") do
		tinsert(cmdtbl, v)
	end
  local cb = cmdfuncs[cmdtbl[1]] 
  if cb then
  	local s = tonumber(cmdtbl[2])
  	local ss = tonumber(cmdtbl[3])
  	cb(s,ss)
  else
	ChatFrame1:AddMessage("scale <number> | " .. JukedDB.scale,0,1,0)
  	ChatFrame1:AddMessage("hidden (toggle) Hide when off CD | " .. tostring(JukedDB.hidden),0,1,0)
	ChatFrame1:AddMessage("smart (toggle) Only show CD when used | " .. tostring(JukedDB.smart),0,1,0)
  	ChatFrame1:AddMessage("lock (toggle) | " .. tostring(JukedDB.lock),0,1,0)
	local grow=false;
	if (JukedDB.growUp==-1) then grow=true; end
	ChatFrame1:AddMessage("growup (toggle) | " .. tostring(JukedDB.growUp==-1),0,1,0)
	ChatFrame1:AddMessage("prio (toggle second anchor w/ priority spells) | " .. tostring(JukedDB.prio),0,1,0)
	ChatFrame1:AddMessage("arenaonly (toggle arena only mode) | " .. tostring(JukedDB.arenaOnly),0,1,0)
	ChatFrame1:AddMessage("bgonly (toggle bg only mode) | " .. tostring(JukedDB.bgOnly),0,1,0)
	ChatFrame1:AddMessage("prioonly (toggle prio only mode) | " .. tostring(JukedDB.prioOnly),0,1,0)
	ChatFrame1:AddMessage("nocd (toggle cd display) | " .. tostring(JukedDB.noCD),0,1,0)
	ChatFrame1:AddMessage("cols <bar ID(1=main, 2=prio)> <num> (0 = 1 row) | bar1=" .. tostring(JukedDB.cols).." bar2=" .. tostring(JukedDB.colsPrio),0,1,0)
  	ChatFrame1:AddMessage("test (execute)",0,1,0)
  	ChatFrame1:AddMessage("reset (execute)",0,1,0)
  end
end

local function Juked_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	if not JukedDB.scale then JukedDB.scale = 1 end
	if not JukedDB.hidden then JukedDB.hidden = false end
	if not JukedDB.smart then JukedDB.smart = false end
	if not JukedDB.prio then JukedDB.prio = false end
	if not JukedDB.growUp then JukedDB.growUp=1 end
	if not JukedDB.arenaOnly then JukedDB.arenaOnly=false end
	if not JukedDB.bgOnly then JukedDB.bgOnly=false end
	if not JukedDB.noCD then JukedDB.noCD=false end
	if not JukedDB.cols then JukedDB.cols = 6 end
	if not JukedDB.colsPrio then JukedDB.colsPrio = 6 end
	if not JukedDB.prioOnly then JukedDB.prioOnly=false end
	if not JukedDB.lock then JukedDB.lock = false end
	Juked_CreateBar()
	
	SlashCmdList["Juked"] = Juked_Command
	SLASH_Juked1 = "/juked"
	SLASH_Juked2 = "/jd"
	SLASH_Juked3 = "/ib"
	ChatFrame1:AddMessage("Juked by Robrman, inspired by Kollektiv's InterruptBar. Type /juked or /jd for options.",0,1,0)
end

local eventhandler = {
	["VARIABLES_LOADED"] = function(self) Juked_OnLoad(self) end,
	["PLAYER_ENTERING_WORLD"] = function(self) Juked_PLAYER_ENTERING_WORLD(self) end,
	["COMBAT_LOG_EVENT_UNFILTERED"] = function(self,...) Juked_COMBAT_LOG_EVENT_UNFILTERED(...) end,
}

local function Juked_OnEvent(self,event,...)
	eventhandler[event](self,...)
end

frame = CreateFrame("Frame",nil,UIParent)
frame:SetScript("OnEvent",Juked_OnEvent)
frame:RegisterEvent("VARIABLES_LOADED")
